const path = require('path')
const fs = require('fs-extra')
const findWorkspaceRoot = require('find-yarn-workspace-root')
const { run } = require('@toptal/davinci-cli-shared')

const getPackageName = config => config.name

const readPackageJson = folder => {
  const packageJsonFile = path.join(folder, 'package.json')

  const configData = fs.readFileSync(packageJsonFile)
  let config

  try {
    config = JSON.parse(configData)
  } catch (e) {
    console.warn(`package.json file from ${folder} can't be parsed as valid JSON. Error: `, e)
  }

  return config
}

const installDependencies = folder =>
  run('yarn', ['install'], { cwd: folder })

module.exports = {
  getRootDir: findWorkspaceRoot,
  readPackageJson,
  getPackageName,
  installDependencies
}
